package linkedlist;

import java.util.HashSet;

/**
 * 题目： 142. 环形链表 II  (detectCycle)
 * 描述：给定一个链表的头节点  head ，返回链表开始入环的第一个节点。 如果链表无环，则返回 null。
 * 如果链表中有某个节点，可以通过连续跟踪 next 指针再次到达，则链表中存在环。 为了表示给定链表中的环，评测系统内部使用整数 pos 来表示链表尾连接到链表中的位置（索引从 0 开始）。如果 pos 是 -1，则在该链表中没有环。注意：pos 不作为参数进行传递，仅仅是为了标识链表的实际情况。
 * 不允许修改 链表。
 进阶：你是否可以使用 O(1) 空间解决此题？

 * 链接：https://leetcode.cn/problems/linked-list-cycle-ii/

 */
//二刷不会做 推导忘记
public class DetectCycle {
    //哈希
    public ListNode detectCycle1(ListNode head) {
        ListNode pos = head;
        HashSet<ListNode> visited = new HashSet<ListNode>();
        while (pos != null) {
            if (visited.contains(pos)) {
                return pos;
            } else {
                visited.add(pos);
            }
            pos = pos.next;
        }
        return null;
    }
    //Floyd 快慢指针 如果链表中存在环，则 fast 指针最终将再次与 slow 指针在环中相遇。
    public ListNode detectCycle(ListNode head) {
        if (head == null) return null;
        ListNode slow = head, fast = head;
        // 当 fast 或 fast.next 为 null 时跳出，说明无环
        while (fast != null && fast.next != null) {
            slow = slow.next;          // 慢指针走一步
            fast = fast.next.next;     // 快指针走两步
            if (slow == fast) {        // 相遇——确认有环
                // 第二阶段：找到环的入口
                ListNode ptr = head;
                while (ptr != slow) {
                    ptr  = ptr.next;
                    slow = slow.next;
                }
                return ptr;
            }
        }
        return null;  // fast 走到末尾， 无环
    }
}
