package linkedlist;

import java.util.HashSet;

/**
 * 题目：160. 相交链表  (getIntersectionNode)
 * 描述：给你两个单链表的头节点 headA 和 headB ，请你找出并返回两个单链表相交的起始节点。如果两个链表不存在相交节点，返回 null 。
 *
 进阶：你能否设计一个时间复杂度 O(m + n) 、仅用 O(1) 内存的解决方案？
 * 链接：https://leetcode.cn/problems/intersection-of-two-linked-lists/

 */

//没想出高效方法
//二刷会做
public class GetIntersectionNode {
    public ListNode getIntersectionNode1(ListNode headA, ListNode headB) {
        HashSet<ListNode> visited = new HashSet<ListNode>();
        ListNode temp = headA;
        while (temp != null) {
            visited.add(temp);
            temp = temp.next;
        }
        temp = headB;
        while (temp != null) {
            if (visited.contains(temp)) {
                return temp;
            }
            temp = temp.next;
        }
        return null;
    }
    //二刷想到的，时间复杂度O(m + n)，但是有点啰嗦
    public ListNode getIntersectionNode2(ListNode headA, ListNode headB) {
        int lenA = 0, lenB = 0;
        ListNode curA = headA, curB = headB;

        // 1. 统计长度
        while (curA != null) {
            lenA++;
            curA = curA.next;
        }
        while (curB != null) {
            lenB++;
            curB = curB.next;
        }

        // 2. 让长的链表先走差值步
        curA = headA;
        curB = headB;
        if (lenA > lenB) {
            for (int i = 0; i < lenA - lenB; i++) curA = curA.next;
        } else {
            for (int i = 0; i < lenB - lenA; i++) curB = curB.next;
        }

        // 3. 同时前进，找相遇点
        while (curA != null && curB != null) {
            if (curA == curB) return curA; // 找到相交点
            curA = curA.next;
            curB = curB.next;
        }

        return null; // 不相交
    }

    //高效方法，链表 A 的长度为 m = a + c（a 是独有部分，c 是公共部分）  链表 B 的长度为 n = b + c  要么相遇在交点，要么都走到 null。
    public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
        ListNode A = headA, B = headB;
        while (A != B) {
            A = A != null ? A.next : headB;
            B = B != null ? B.next : headA;
        }
        return A;
    }
}
