package linkedlist;

import java.util.Deque;
import java.util.HashMap;
import java.util.LinkedList;

/**
 * 题目： 19. 删除链表的倒数第 N 个结点  (removeNthFromEnd)
 * 描述：给你一个链表，删除链表的倒数第 n 个结点，并且返回链表的头结点。
 进阶：你能尝试使用一趟扫描实现吗？
 * 链接：https://leetcode.cn/problems/remove-nth-node-from-end-of-list/

 */
//二刷会做
public class RemoveNthFromEnd {
    //思路：
    //1. 遍历一遍链表，用哈希表存储每个节点的位置
    //2. 找到倒数第n个节点的前一个节点，修改指针
    //3. 注意边界情况，如删除头节点
    public ListNode removeNthFromEnd1(ListNode head, int n) {
        HashMap<Integer,ListNode>map=new HashMap<>();
        int k=0;
        ListNode cur=head;
        while (cur!=null){
            map.put(k++,cur);
            cur=cur.next;
        }
        if(k-n==0)
            return head.next;
        ListNode pre=map.get(k-n-1);
        pre.next= map.get(k-n+1);
        return head;
    }
    //入栈 出栈
    //思路：
    //1. 遍历一遍链表，用栈存储每个节点
    //2. 找到倒数第n个节点的前一个节点，修改指针
    //3. 注意边界情况，如删除头节点
    public ListNode removeNthFromEnd2(ListNode head, int n) {
        ListNode dummy = new ListNode(0,head);
        Deque<ListNode> stack = new LinkedList<>();
        ListNode cur = dummy;
        while (cur != null) {
            stack.push(cur);
            cur = cur.next;
        }
        for (int i = 0; i < n; ++i) {
            stack.pop();
        }
        ListNode prev = stack.peek();
        prev.next = prev.next.next;
        ListNode ans = dummy.next;
        return ans;
    }

    //思路：
    //1. 定义两个指针，first和second，都指向 dummy
    //2. 让 first 向前走 n+1 步
    //3. 同时移动，两指针保持 n+1 步差距
    //4. 此时 second.next 是要删除的节点，直接跳过它
    //5. 返回删除后的链表头
    public ListNode removeNthFromEnd(ListNode head, int n) {
        // 1. 创建虚拟头节点
        ListNode dummy = new ListNode(0);
        dummy.next = head;

        // 2. 初始化快慢指针，都指向 dummy
        ListNode first = dummy;
        ListNode second = dummy;

        // 3. 先让 first 向前走 n+1 步
        for (int i = 0; i < n + 1; i++) {
            first = first.next;
        }

        // 4. 同时移动，两指针保持 n+1 步差距
        while (first != null) {
            first = first.next;
            second = second.next;
        }

        // 5. 此时 second.next 是要删除的节点，直接跳过它
        second.next = second.next.next;

        // 6. 返回删除后的链表头
        return dummy.next;
    }

}
