package linkedlist;
/**
 * 题目： 82. 删除排序链表中的重复元素 II (deleteDuplicates)
 * 描述：给定一个已排序的链表的头 head ， 删除原始链表中所有重复数字的节点，只留下不同的数字 。返回 已排序的链表 。

 示例 2：
 输入：head = [1,2,3,3,4,4,5]
 输出：[1,2,5]

 * 链接：https://leetcode.cn/problems/remove-duplicates-from-sorted-list-ii/
 */
public class ReverseKGroup {
    // 反转 [head, tail] 这一段，返回新的头和新的尾
    private ListNode[] reverse(ListNode head, ListNode tail) {
        ListNode prev = tail.next;
        ListNode p = head;
        while (prev != tail) {
            ListNode nxt = p.next;
            p.next = prev;
            prev = p;
            p = nxt;
        }
        // 反转后，tail 变成新头，head 变成新尾
        return new ListNode[]{ tail, head };
    }

    public ListNode reverseKGroup(ListNode head, int k) {
        ListNode dummy = new ListNode(-1);
        dummy.next = head;             // ←—— 关键：把 dummy.next 指向原始 head
        ListNode pre = dummy;

        while (true) {
            // 检查剩余是否至少有 k 个节点
            ListNode tail = pre;
            for (int i = 0; i < k; i++) {
                tail = tail.next;
                if (tail == null) {
                    // 不足 k 个，直接返回
                    return dummy.next;
                }
            }
            ListNode nextGroupHead = tail.next;
            // 反转 pre.next ... tail 这一段
            ListNode[] reversed = reverse(pre.next, tail);
            // 接上前半段：pre → reversedHead
            pre.next = reversed[0];
            // reversedTail → nextGroupHead
            reversed[1].next = nextGroupHead;
            // 移动 pre 到这一段反转后的尾部，为下一轮做准备
            pre = reversed[1];
        }
    }
}
